var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { getClassName } from '@react-devui/utils';
import { registerComponentMate, TTANSITION_DURING_BASE } from '../../utils';
import { DTransition } from '../_transition';
import { useComponentConfig, usePrefixConfig } from '../root';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DBadge.Text' });
export function DBadgeText(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dText, dTheme = 'danger', dColor, dOffset = [0, '100%'], dAlone = false } = _a, restProps = __rest(_a, ["dText", "dTheme", "dColor", "dOffset", "dAlone"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    return (_jsx(DTransition, Object.assign({ dIn: dText.length > 0, dDuring: TTANSITION_DURING_BASE }, { children: (state) => {
            var _a;
            let transitionStyle = {};
            switch (state) {
                case 'enter':
                    transitionStyle = { transform: 'scale(0)', opacity: 0 };
                    break;
                case 'entering':
                    transitionStyle = {
                        transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-out`).join(', '),
                    };
                    break;
                case 'leaving':
                    transitionStyle = {
                        transform: 'scale(0)',
                        opacity: 0,
                        transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-in`).join(', '),
                    };
                    break;
                default:
                    break;
            }
            return state === 'leaved' ? null : (_jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}badge`, {
                    [`t-${dTheme}`]: dTheme,
                    [`${dPrefix}badge--alone`]: dAlone,
                }), style: Object.assign(Object.assign(Object.assign({}, restProps.style), (dAlone
                    ? {}
                    : {
                        top: dOffset[0],
                        left: dOffset[1],
                    })), { [`--${dPrefix}badge-color`]: dColor }), title: (_a = restProps.title) !== null && _a !== void 0 ? _a : dText }, { children: _jsx("div", Object.assign({ className: `${dPrefix}badge__wrapper`, style: transitionStyle }, { children: dText })) })));
        } })));
}
