/// <reference types="react" />
import type { DCloneHTMLElement } from '../../utils/types';
import type { DFormControl } from '../form';
export interface DSwitchProps extends React.HTMLAttributes<HTMLElement> {
    dRef?: {
        input?: React.ForwardedRef<HTMLInputElement>;
    };
    dFormControl?: DFormControl;
    dModel?: boolean;
    dLabelPlacement?: 'left' | 'right';
    dStateContent?: [React.ReactNode, React.ReactNode];
    dDisabled?: boolean;
    dLoading?: boolean;
    dInputRender?: DCloneHTMLElement<React.InputHTMLAttributes<HTMLInputElement>>;
    onModelChange?: (checked: boolean) => void;
}
export declare function DSwitch(props: DSwitchProps): JSX.Element | null;
